//-----------------------------------------------------------------------------
// File: texture_filter.h
//
// Desc: Header file texture_filter sample app
//-----------------------------------------------------------------------------
#pragma once


#define MYTEXTURE0				"texture/"	"Texture9.dds"
#define MYTEXTURE1				"texture/"	"m2st02_goodness_wood.dds"

//-----------------------------------------------------------------------------
// Defines, and constants
//-----------------------------------------------------------------------------
// TODO: change "DirectX AppWizard Apps" to your name or the company name
#define DXAPP_KEY        TEXT("Software\\DirectX AppWizard Apps\\texture_filter")

// Struct to store the current input state
struct UserInput
{
    // TODO: change as needed
    BOOL bRotateUp;
    BOOL bRotateDown;
    BOOL bRotateLeft;
    BOOL bRotateRight;
	
	BOOL bMoveForward;
	BOOL bMoveBackward;
	BOOL bMoveStrafeLeft;
	BOOL bMoveStrafeRight;

	BOOL bLMouse;
	BOOL bRMouse;
};




//-----------------------------------------------------------------------------
// Name: class CMyD3DApplication
// Desc: Application class. The base class (CD3DApplication) provides the 
//       generic functionality needed in all Direct3D samples. CMyD3DApplication 
//       adds functionality specific to this sample program.
//-----------------------------------------------------------------------------
class CMyD3DApplication : public CD3DApplication
{
    BOOL                    m_bLoadingApp;          // TRUE, if the app is loading
    CD3DFont*               m_pFont;                // Font for drawing text

    UserInput               m_UserInput;            // Struct for storing user input 

	POINT					m_ptBackBuffer;			// BackBuffer Size (== ClientAreaSize)
	POINT					m_ptPrevCursor;			// Cursor Position on previous FrameMove().

	D3DXVECTOR3			m_vecFromPt;

	FLOAT					m_fViewRotYaxis;		//Angle, vecViewDir Rotation around Y-axis by.
	FLOAT					m_fViewRotXaxis;		//Angle, vecViewDir Rotation around X-axis by.

	D3DTEXTUREFILTERTYPE	m_TextureFilterType;
	D3DTEXTUREFILTERTYPE	m_TextureMipFilterType;
	UINT					m_MaxAnisotropy;
	DWORD					m_dwTargetTextureStage;
	BOOL					m_bTextureBlendAlpha;

	IDirect3DTexture9**			m_ppd3dTexturePipe;
	IDirect3DTexture9*			m_pd3dTexture0;
	IDirect3DTexture9*			m_pd3dTexture1;
	IDirect3DTexture9*			m_pd3dTextureByUser;
	ID3DXMesh*					m_pd3dxMeshPipe;
	ID3DXMesh*					m_pd3dxMeshWall;

protected:
	void SetTextureFilterState();
    virtual HRESULT OneTimeSceneInit();
    virtual HRESULT InitDeviceObjects();
    virtual HRESULT RestoreDeviceObjects();
    virtual HRESULT InvalidateDeviceObjects();
    virtual HRESULT DeleteDeviceObjects();
    virtual HRESULT Render();
    virtual HRESULT FrameMove();
    virtual HRESULT FinalCleanup();
    virtual HRESULT ConfirmDevice( D3DCAPS9*, DWORD, D3DFORMAT );

    HRESULT RenderText();

    void    UpdateInput( UserInput* pUserInput );

    VOID    ReadSettings();
    VOID    WriteSettings();

public:
    LRESULT MsgProc( HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam );
    CMyD3DApplication();
    virtual ~CMyD3DApplication();
};

